<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1media_player.html">mediaPlayer</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1media_player_1_1android.html">android</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html">FFmpegStreamInputController</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_f_fmpeg_stream_input_controller_8h_source.html">FFmpegStreamInputController.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller_inherit__map" id="alexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html" title="alexaClientSDK::mediaPlayer\l::android::FFmpegInputController\lInterface" alt="" coords="27,5,245,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller_coll__map" id="alexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html" title="alexaClientSDK::mediaPlayer\l::android::FFmpegInputController\lInterface" alt="" coords="27,5,245,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a66312960167cf98a7f6cae0047441454"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html#a66312960167cf98a7f6cae0047441454">~FFmpegStreamInputController</a> ()</td></tr>
<tr class="separator:a66312960167cf98a7f6cae0047441454"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">FFmpegInputControllerInterface methods</div></td></tr>
<tr class="memitem:a11700471ce259f950772c33cabc9728a"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html#a11700471ce259f950772c33cabc9728a">hasNext</a> () const override</td></tr>
<tr class="separator:a11700471ce259f950772c33cabc9728a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2eac8b12dc7e8ae4aacf678b7da5003d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html#a2eac8b12dc7e8ae4aacf678b7da5003d">next</a> () override</td></tr>
<tr class="separator:a2eac8b12dc7e8ae4aacf678b7da5003d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ff8fbf584e8448a235f5010c1653029"><td class="memItemLeft" align="right" valign="top">std::tuple&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a154edb0d28b72a64d7bbec454c2fde7b">Result</a>, std::shared_ptr&lt; AVFormatContext &gt;, std::chrono::milliseconds &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html#a0ff8fbf584e8448a235f5010c1653029">getCurrentFormatContext</a> () override</td></tr>
<tr class="separator:a0ff8fbf584e8448a235f5010c1653029"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html">alexaClientSDK::mediaPlayer::android::FFmpegInputControllerInterface</a></td></tr>
<tr class="memitem:a03b9fd09c97ab4dd350ffd3e5b9ffba1 inherit pub_methods_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a03b9fd09c97ab4dd350ffd3e5b9ffba1">~FFmpegInputControllerInterface</a> ()=default</td></tr>
<tr class="separator:a03b9fd09c97ab4dd350ffd3e5b9ffba1 inherit pub_methods_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a1273664dfa426cbe2e9a942fd07b350d"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html">FFmpegStreamInputController</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html#a1273664dfa426cbe2e9a942fd07b350d">create</a> (std::shared_ptr&lt; std::istream &gt; stream, bool repeat)</td></tr>
<tr class="separator:a1273664dfa426cbe2e9a942fd07b350d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html">alexaClientSDK::mediaPlayer::android::FFmpegInputControllerInterface</a></td></tr>
<tr class="memitem:a154edb0d28b72a64d7bbec454c2fde7b inherit pub_types_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a154edb0d28b72a64d7bbec454c2fde7b">Result</a> { <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a154edb0d28b72a64d7bbec454c2fde7bae0aa021e21dddbd6d8cecec71e9cf564">Result::OK</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a154edb0d28b72a64d7bbec454c2fde7ba7f873066b6a00fc1bc728c3063bec9eb">Result::TRY_AGAIN</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a154edb0d28b72a64d7bbec454c2fde7babb1ca97ec761fc37101737ba0aa2e7c5">Result::ERROR</a>
 }</td></tr>
<tr class="memdesc:a154edb0d28b72a64d7bbec454c2fde7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Enumeration class that represents the possible return values for <code>getContext</code>.  <a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a154edb0d28b72a64d7bbec454c2fde7b">More...</a><br /></td></tr>
<tr class="separator:a154edb0d28b72a64d7bbec454c2fde7b inherit pub_types_classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This class provides the <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_decoder.html">FFmpegDecoder</a> input access to the content of an input stream.</p>
<p class="">This class support repeat functionality implemented by returning <code>true</code> to <code>hasNext</code> and rewinding the stream pointer when <code>next</code> is called. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a66312960167cf98a7f6cae0047441454"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a66312960167cf98a7f6cae0047441454">&#9670;&nbsp;</a></span>~FFmpegStreamInputController()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController::~FFmpegStreamInputController </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a1273664dfa426cbe2e9a942fd07b350d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1273664dfa426cbe2e9a942fd07b350d">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html">FFmpegStreamInputController</a> &gt; alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController::create </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; std::istream &gt;&#160;</td>
          <td class="paramname"><em>stream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>repeat</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates an input stream object.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">input</td><td>A pointer to the input stream. It shall point to a valid object. </td></tr>
    <tr><td class="paramname">repeat</td><td>Whether to play the input stream in a loop. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_stream_input_controller.html">FFmpegStreamInputController</a></code> if succeed; <code>nullptr</code> otherwise. </dd></dl>

</div>
</div>
<a id="a0ff8fbf584e8448a235f5010c1653029"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0ff8fbf584e8448a235f5010c1653029">&#9670;&nbsp;</a></span>getCurrentFormatContext()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::tuple&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#a154edb0d28b72a64d7bbec454c2fde7b">FFmpegInputControllerInterface::Result</a>, std::shared_ptr&lt; AVFormatContext &gt;, std::chrono::milliseconds &gt; alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController::getCurrentFormatContext </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This method will initialize the ffmpeg format context that represents the current input stream.</p>
<dl class="section return"><dt>Returns</dt><dd>A tuple with the return result, a pointer to <code>AVFormatContext</code> and the initial playback position. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#af6451994687a9217b72a8510409425ef">alexaClientSDK::mediaPlayer::android::FFmpegInputControllerInterface</a>.</p>

</div>
</div>
<a id="a11700471ce259f950772c33cabc9728a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a11700471ce259f950772c33cabc9728a">&#9670;&nbsp;</a></span>hasNext()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController::hasNext </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Checks if there is a next track to be played.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if there is a next track; false, otherwise. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#ab111e0a7ce382bb3092d71cd8071963f">alexaClientSDK::mediaPlayer::android::FFmpegInputControllerInterface</a>.</p>

</div>
</div>
<a id="a2eac8b12dc7e8ae4aacf678b7da5003d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2eac8b12dc7e8ae4aacf678b7da5003d">&#9670;&nbsp;</a></span>next()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::mediaPlayer::android::FFmpegStreamInputController::next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Change input to the next track to be played.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if it succeeds to change; false, otherwise. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html#aea4b0bc6d5e9b4fad2a32edf3f60e3a2">alexaClientSDK::mediaPlayer::android::FFmpegInputControllerInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/MediaPlayer/AndroidSLESMediaPlayer/include/AndroidSLESMediaPlayer/<a class="el" href="_f_fmpeg_stream_input_controller_8h_source.html">FFmpegStreamInputController.h</a></li>
<li>/workplace/avs-device-sdk/MediaPlayer/AndroidSLESMediaPlayer/src/<a class="el" href="_f_fmpeg_stream_input_controller_8cpp.html">FFmpegStreamInputController.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
